package com.cedarsoft.business;

import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;

/**
 *
 */
public class Bank {
  @NotNull
  @NonNls
  public static final String PROPERTY_CODE = "code";
  @NotNull
  @NonNls
  public static final String PROPERTY_IDENTIFICATION = "identification";

  @NotNull
  public static final Bank NULL = new Bank( "", "" );

  private Long id;

  @NotNull
  @NonNls
  private final String code;
  @NotNull
  @NonNls
  private final String identification;

  /**
   * Hibernate
   */
  @Deprecated
  protected Bank() {
    code = null;
    identification = null;
  }

  public Bank( @NotNull String code, @NotNull String identification ) {
    this.code = code;
    this.identification = identification;
  }

  @NotNull
  public String getCode() {
    return code;
  }

  @NotNull
  public String getIdentification() {
    return identification;
  }

  @Override
  public boolean equals( Object o ) {
    if ( this == o ) return true;
    if ( o == null || getClass() != o.getClass() ) return false;

    Bank bank = ( Bank ) o;

    if ( !code.equals( bank.code ) ) return false;
    if ( !identification.equals( bank.identification ) ) return false;

    return true;
  }

  @Override
  public int hashCode() {
    int result;
    result = code.hashCode();
    result = 31 * result + identification.hashCode();
    return result;
  }

  @Override
  public String toString() {
    return "Bank{" +
        "code='" + code + '\'' +
        ", name='" + identification + '\'' +
        '}';
  }
}
