package com.cedarsoft.business.contact;

import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;

/**
 * Represents a city.
 */
public class City {
  @NotNull
  public static final City NULL = new City( "", "" );
  @NotNull
  @NonNls
  public static final String PROPERTY_POSTAL_CODE = "postalCode";
  @NotNull
  @NonNls
  public static final String PROPERTY_NAME = "name";
  private Long id;
  @NotNull
  @NonNls
  private final String postalCode;
  @NotNull
  @NonNls
  private final String name;

  /**
   * Hibernate
   */
  @Deprecated
  protected City() {
    postalCode = "";
    name = "";
  }

  public City( @NonNls @NotNull String postalCode, @NonNls @NotNull String name ) {
    this.postalCode = postalCode;
    this.name = name;
  }

  @NotNull
  @NonNls
  public String getName() {
    return name;
  }

  @NotNull
  @NonNls
  public String getPostalCode() {
    return postalCode;
  }

  @Override
  public boolean equals( Object obj ) {
    if ( this == obj ) {
      return true;
    }
    if ( obj == null || getClass() != obj.getClass() ) {
      return false;
    }

    City city = ( City ) obj;

    if ( name != null ? !name.equals( city.name ) : city.name != null ) {
      return false;
    }
    if ( postalCode != null ? !postalCode.equals( city.postalCode ) : city.postalCode != null ) {
      return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    int result;
    result = ( postalCode != null ? postalCode.hashCode() : 0 );
    result = 31 * result + ( name != null ? name.hashCode() : 0 );
    return result;
  }

  @Override
  public String toString() {
    return postalCode + ' ' + name;
  }
}